(benchmark reader_writer
  :status unknown
  :extrasorts (Unit)
:extrasorts (c_unique)
:extrasorts (c_ssorted)
:extrasorts (c_type)
:extrasorts (c_Boolean)
;;;; Why logic c_sort
:extrafuns ((c_sort c_type c_unique c_ssorted))

;;;; Why logic c_Boolean_true
:extrafuns ((c_Boolean_true  c_Boolean))

;;;; Why logic c_Boolean_false
:extrafuns ((c_Boolean_false  c_Boolean))

;; Why axiom either true_or_false_c_to_either true_or_false_c
 :assumption
   (forall (?b_22_1 c_Boolean)
   (or (= c_Boolean_true ?b_22_1) (= c_Boolean_false ?b_22_1)))

;; Why axiom true_neq_false_c_to_true_neq_false_c
 :assumption (not (= c_Boolean_true c_Boolean_false))

;;;; Why logic int2U
:extrafuns ((int2U Int c_unique))

;;;; Why logic ss2Int
:extrafuns ((ss2Int c_ssorted Int))

;;;; Why logic real2U
:extrafuns ((real2U Real c_unique))

;;;; Why logic ss2Real
:extrafuns ((ss2Real c_ssorted Real))

;;;; Why logic bool2U
:extrafuns ((bool2U c_Boolean c_unique))

;;;; Why logic ss2Bool
:extrafuns ((ss2Bool c_ssorted c_Boolean))

;;;; Why logic c_int
:extrafuns ((c_int  c_type))

;;;; Why logic c_bool
:extrafuns ((c_bool  c_type))

;;;; Why logic c_real
:extrafuns ((c_real  c_type))

;;;; Why logic c_unit
:extrafuns ((c_unit  c_type))

;;;; Why logic c_ref
:extrafuns ((c_ref c_unique c_unique))

;; Why axiom c__c_to_c__csort_is_injective
 :assumption
   (forall (?t_21_2 c_type)
   (forall (?x_20_3 c_unique)
   (forall (?y_19_4 c_unique)
   (implies (= (c_sort ?t_21_2 ?x_20_3) (c_sort ?t_21_2 ?y_19_4))
   (= ?x_20_3 ?y_19_4)))))

;; Why axiom eq__c_to_eq__css2Int_int2U
 :assumption
   (forall (?x_18_5 Int) (= (ss2Int (c_sort c_int (int2U ?x_18_5))) ?x_18_5))

;; Why axiom int2U_c_to_int2U_c_is_injective
 :assumption
   (forall (?x_17_6 Int)
   (forall (?y_16_7 Int)
   (implies (= (int2U ?x_17_6) (int2U ?y_16_7)) (= ?x_17_6 ?y_16_7))))

;; Why axiom real2U_c_to_real2U_c_is_injective
 :assumption
   (forall (?x_15_8 Real)
   (forall (?y_14_9 Real)
   (implies (= (real2U ?x_15_8) (real2U ?y_14_9)) (= ?x_15_8 ?y_14_9))))

;; Why axiom bool2U_c_to_bool2U_c_is_injective
 :assumption
   (forall (?x_13_10 c_Boolean)
   (forall (?y_12_11 c_Boolean)
   (implies (= (bool2U ?x_13_10) (bool2U ?y_12_11)) (= ?x_13_10 ?y_12_11))))

;; Why axiom ss2Int_c_to_ss2Int_c_is_injective
 :assumption
   (forall (?x_11_12 c_ssorted)
   (forall (?y_10_13 c_ssorted)
   (implies (= (ss2Int ?x_11_12) (ss2Int ?y_10_13)) (= ?x_11_12 ?y_10_13))))

;; Why axiom ss2Real_c_to_ss2Real_c_is_injective
 :assumption
   (forall (?x_9_14 c_ssorted)
   (forall (?y_8_15 c_ssorted)
   (implies (= (ss2Real ?x_9_14) (ss2Real ?y_8_15)) (= ?x_9_14 ?y_8_15))))

;; Why axiom ss2Bool_c_to_ss2Bool_c_is_injective
 :assumption
   (forall (?x_7_16 c_ssorted)
   (forall (?y_6_17 c_ssorted)
   (implies (= (ss2Bool ?x_7_16) (ss2Bool ?y_6_17)) (= ?x_7_16 ?y_6_17))))

;; Why axiom eq__c_to_eq__css2Real_real2U
 :assumption
   (forall (?x_5_18 Real)
   (= (ss2Real (c_sort c_real (real2U ?x_5_18))) ?x_5_18))

;; Why axiom eq__c_to_eq__css2Bool_bool2U
 :assumption
   (forall (?x_4_19 c_Boolean)
   (= (ss2Bool (c_sort c_bool (bool2U ?x_4_19))) ?x_4_19))

;; Why axiom eq__c_to_eq__cint2U_ss2Int
 :assumption
   (forall (?x_3_20 c_unique)
   (= (int2U (ss2Int (c_sort c_int ?x_3_20))) ?x_3_20))

;; Why axiom eq__c_to_eq__creal2U_ss2Real
 :assumption
   (forall (?x_2_21 c_unique)
   (= (real2U (ss2Real (c_sort c_real ?x_2_21))) ?x_2_21))

;; Why axiom eq__c_to_eq__cbool2U_ss2Bool
 :assumption
   (forall (?x_1_22 c_unique)
   (= (bool2U (ss2Bool (c_sort c_bool ?x_1_22))) ?x_1_22))

;;;; Why logic eq_int
:extrapreds ((eq_int Int Int))

;;;; Why logic neq_int
:extrapreds ((neq_int Int Int))

;;;; Why logic lt_int_bool
:extrafuns ((lt_int_bool Int Int c_Boolean))

;;;; Why logic le_int_bool
:extrafuns ((le_int_bool Int Int c_Boolean))

;;;; Why logic gt_int_bool
:extrafuns ((gt_int_bool Int Int c_Boolean))

;;;; Why logic ge_int_bool
:extrafuns ((ge_int_bool Int Int c_Boolean))

;;;; Why logic eq_int_bool
:extrafuns ((eq_int_bool Int Int c_Boolean))

;;;; Why logic neq_int_bool
:extrafuns ((neq_int_bool Int Int c_Boolean))

;; Why axiom lt_int_bool_axiom
 :assumption
   (forall (?x_40_23 Int)
   (forall (?y_39_24 Int)
   (iff (= (lt_int_bool ?x_40_23 ?y_39_24) c_Boolean_true)
   (< ?x_40_23 ?y_39_24))))

;; Why axiom le_int_bool_axiom
 :assumption
   (forall (?x_42_25 Int)
   (forall (?y_41_26 Int)
   (iff (= (le_int_bool ?x_42_25 ?y_41_26) c_Boolean_true)
   (<= ?x_42_25 ?y_41_26))))

;; Why axiom gt_int_bool_axiom
 :assumption
   (forall (?x_44_27 Int)
   (forall (?y_43_28 Int)
   (iff (= (gt_int_bool ?x_44_27 ?y_43_28) c_Boolean_true)
   (> ?x_44_27 ?y_43_28))))

;; Why axiom ge_int_bool_axiom
 :assumption
   (forall (?x_46_29 Int)
   (forall (?y_45_30 Int)
   (iff (= (ge_int_bool ?x_46_29 ?y_45_30) c_Boolean_true)
   (>= ?x_46_29 ?y_45_30))))

;; Why axiom eq_int_bool_axiom
 :assumption
   (forall (?x_48_31 Int)
   (forall (?y_47_32 Int)
   (iff (= (eq_int_bool ?x_48_31 ?y_47_32) c_Boolean_true)
   (= ?x_48_31 ?y_47_32))))

;; Why axiom neq_int_bool_axiom
 :assumption
   (forall (?x_50_33 Int)
   (forall (?y_49_34 Int)
   (iff (= (neq_int_bool ?x_50_33 ?y_49_34) c_Boolean_true)
   (not (= ?x_50_33 ?y_49_34)))))

;;;; Why logic add_real
:extrafuns ((add_real Real Real Real))

;;;; Why logic sub_real
:extrafuns ((sub_real Real Real Real))

;;;; Why logic mul_real
:extrafuns ((mul_real Real Real Real))

;;;; Why logic div_real
:extrafuns ((div_real Real Real Real))

;;;; Why logic pow_real
:extrafuns ((pow_real Real Real Real))

;;;; Why logic neg_real
:extrafuns ((neg_real Real Real))

;;;; Why logic abs_real
:extrafuns ((abs_real Real Real))

;;;; Why logic sqrt_real
:extrafuns ((sqrt_real Real Real))

;;;; Why logic real_of_int
:extrafuns ((real_of_int Int Real))

;;;; Why logic int_of_real
:extrafuns ((int_of_real Real Int))

;;;; Why logic lt_real
:extrapreds ((lt_real Real Real))

;;;; Why logic le_real
:extrapreds ((le_real Real Real))

;;;; Why logic gt_real
:extrapreds ((gt_real Real Real))

;;;; Why logic ge_real
:extrapreds ((ge_real Real Real))

;;;; Why logic eq_real
:extrapreds ((eq_real Real Real))

;;;; Why logic neq_real
:extrapreds ((neq_real Real Real))

;;;; Why logic eq_bool
:extrapreds ((eq_bool c_Boolean c_Boolean))

;;;; Why logic neq_bool
:extrapreds ((neq_bool c_Boolean c_Boolean))

;;;; Why logic eq_unit
:extrapreds ((eq_unit c_ssorted c_ssorted))

;;;; Why logic neq_unit
:extrapreds ((neq_unit c_ssorted c_ssorted))

;;;; Why logic ite
:extrafuns ((smtlib__ite c_Boolean c_ssorted c_ssorted c_unique))

;; Why axiom ite_true
 :assumption
   (forall (?t_1_76_35 c_type)
   (forall (?x_75_36 c_unique)
   (forall (?y_74_37 c_unique)
   (= (smtlib__ite c_Boolean_true  (c_sort ?t_1_76_35 ?x_75_36)
      (c_sort ?t_1_76_35 ?y_74_37))
   ?x_75_36))))

;; Why axiom ite_false
 :assumption
   (forall (?t_2_79_38 c_type)
   (forall (?x_78_39 c_unique)
   (forall (?y_77_40 c_unique)
   (= (smtlib__ite c_Boolean_false  (c_sort ?t_2_79_38 ?x_78_39)
      (c_sort ?t_2_79_38 ?y_77_40))
   ?y_77_40))))

;;;; Why logic type_farray
:extrafuns ((type_farray c_type c_type))

;;;; Why logic array_length
:extrafuns ((array_length c_ssorted Int))

;;;; Why logic access
:extrafuns ((access c_ssorted Int c_unique))

;;;; Why logic update
:extrafuns ((update c_ssorted Int c_ssorted c_unique))

;; Why axiom access_update
 :assumption
   (forall (?t_3_89_41 c_type)
   (forall (?t_88_42 c_unique)
   (forall (?i_87_43 Int)
   (forall (?v_86_44 c_unique)
   (= (access
      (c_sort (type_farray ?t_3_89_41)
      (update (c_sort (type_farray ?t_3_89_41) ?t_88_42) ?i_87_43
      (c_sort ?t_3_89_41 ?v_86_44))) ?i_87_43)
   ?v_86_44)))))

;; Why axiom access_update_neq
 :assumption
   (forall (?t_4_94_45 c_type)
   (forall (?t_93_46 c_unique)
   (forall (?i_92_47 Int)
   (forall (?j_91_48 Int)
   (forall (?v_90_49 c_unique)
   (implies (not (= ?i_92_47 ?j_91_48))
   (= (access
      (c_sort (type_farray ?t_4_94_45)
      (update (c_sort (type_farray ?t_4_94_45) ?t_93_46) ?i_92_47
      (c_sort ?t_4_94_45 ?v_90_49))) ?j_91_48)
   (access (c_sort (type_farray ?t_4_94_45) ?t_93_46) ?j_91_48))))))))

;;;; Why logic sorted_array
:extrapreds ((sorted_array c_ssorted Int Int))

;; Why axiom def_sorted_array
 :assumption
   (forall (?t_103_50 c_unique)
   (forall (?i_102_51 Int)
   (forall (?j_101_52 Int)
   (iff
   (sorted_array (c_sort (type_farray c_int) ?t_103_50) ?i_102_51 ?j_101_52)
   (forall (?k_100_53 Int)
   (implies (and (<= ?i_102_51 ?k_100_53) (< ?k_100_53 ?j_101_52))
   (<= (ss2Int
       (c_sort c_int
       (access (c_sort (type_farray c_int) ?t_103_50) ?k_100_53)))
   (ss2Int
   (c_sort c_int
   (access (c_sort (type_farray c_int) ?t_103_50) (+ ?k_100_53 1)))))))))))

;;;; Why logic array_le
:extrapreds ((array_le c_ssorted Int Int Int))

;;;; Why logic array_ge
:extrapreds ((array_ge c_ssorted Int Int Int))

;;;; Why logic exchange
:extrapreds ((exchange c_ssorted c_ssorted Int Int))

;; Why axiom def_exchange
 :assumption
   (forall (?t1_108_54 c_unique)
   (forall (?t2_107_55 c_unique)
   (forall (?i_106_56 Int)
   (forall (?j_105_57 Int)
   (iff
   (exchange (c_sort (type_farray c_int) ?t1_108_54)
   (c_sort (type_farray c_int) ?t2_107_55) ?i_106_56 ?j_105_57)
   (and
   (= (array_length (c_sort (type_farray c_int) ?t1_108_54))
   (array_length (c_sort (type_farray c_int) ?t2_107_55)))
   (and
   (= (access (c_sort (type_farray c_int) ?t1_108_54) ?i_106_56)
   (access (c_sort (type_farray c_int) ?t2_107_55) ?j_105_57))
   (and
   (= (access (c_sort (type_farray c_int) ?t2_107_55) ?i_106_56)
   (access (c_sort (type_farray c_int) ?t1_108_54) ?j_105_57))
   (forall (?k_104_58 Int)
   (implies (and (not (= ?k_104_58 ?i_106_56)) (not (= ?k_104_58 ?j_105_57)))
   (= (access (c_sort (type_farray c_int) ?t1_108_54) ?k_104_58)
   (access (c_sort (type_farray c_int) ?t2_107_55) ?k_104_58))))))))))))

;;;; Why logic permut
:extrapreds ((permut c_ssorted c_ssorted))

;; Why axiom permut_refl
 :assumption
   (forall (?t_109_59 c_unique)
   (permut (c_sort (type_farray c_int) ?t_109_59)
   (c_sort (type_farray c_int) ?t_109_59)))

;; Why axiom permut_sym
 :assumption
   (forall (?t1_111_60 c_unique)
   (forall (?t2_110_61 c_unique)
   (implies
   (permut (c_sort (type_farray c_int) ?t1_111_60)
   (c_sort (type_farray c_int) ?t2_110_61))
   (permut (c_sort (type_farray c_int) ?t2_110_61)
   (c_sort (type_farray c_int) ?t1_111_60)))))

;; Why axiom permut_trans
 :assumption
   (forall (?t1_114_62 c_unique)
   (forall (?t2_113_63 c_unique)
   (forall (?t3_112_64 c_unique)
   (implies
   (and
   (permut (c_sort (type_farray c_int) ?t1_114_62)
   (c_sort (type_farray c_int) ?t2_113_63))
   (permut (c_sort (type_farray c_int) ?t2_113_63)
   (c_sort (type_farray c_int) ?t3_112_64)))
   (permut (c_sort (type_farray c_int) ?t1_114_62)
   (c_sort (type_farray c_int) ?t3_112_64))))))

;; Why axiom permut_exchange
 :assumption
   (forall (?t_117_65 c_unique)
   (forall (?i_116_66 Int)
   (forall (?j_115_67 Int)
   (permut (c_sort (type_farray c_int) ?t_117_65)
   (c_sort (type_farray c_int)
   (update
   (c_sort (type_farray c_int)
   (update (c_sort (type_farray c_int) ?t_117_65) ?i_116_66
   (c_sort c_int (access (c_sort (type_farray c_int) ?t_117_65) ?j_115_67))))
   ?j_115_67
   (c_sort c_int (access (c_sort (type_farray c_int) ?t_117_65) ?i_116_66))))))))

;;;; Why logic sub_permut
:extrapreds ((sub_permut Int Int c_ssorted c_ssorted))

;; Why axiom sub_permut_refl
 :assumption
   (forall (?t_120_68 c_unique)
   (forall (?g_119_69 Int)
   (forall (?d_118_70 Int)
   (sub_permut ?g_119_69 ?d_118_70 (c_sort (type_farray c_int) ?t_120_68)
   (c_sort (type_farray c_int) ?t_120_68)))))

;; Why axiom sub_permut_sym
 :assumption
   (forall (?t1_124_71 c_unique)
   (forall (?t2_123_72 c_unique)
   (forall (?g_122_73 Int)
   (forall (?d_121_74 Int)
   (implies
   (sub_permut ?g_122_73 ?d_121_74 (c_sort (type_farray c_int) ?t1_124_71)
   (c_sort (type_farray c_int) ?t2_123_72))
   (sub_permut ?g_122_73 ?d_121_74 (c_sort (type_farray c_int) ?t2_123_72)
   (c_sort (type_farray c_int) ?t1_124_71)))))))

;; Why axiom sub_permut_trans
 :assumption
   (forall (?t1_129_75 c_unique)
   (forall (?t2_128_76 c_unique)
   (forall (?t3_127_77 c_unique)
   (forall (?g_126_78 Int)
   (forall (?d_125_79 Int)
   (implies
   (sub_permut ?g_126_78 ?d_125_79 (c_sort (type_farray c_int) ?t1_129_75)
   (c_sort (type_farray c_int) ?t2_128_76))
   (implies
   (sub_permut ?g_126_78 ?d_125_79 (c_sort (type_farray c_int) ?t2_128_76)
   (c_sort (type_farray c_int) ?t3_127_77))
   (sub_permut ?g_126_78 ?d_125_79 (c_sort (type_farray c_int) ?t1_129_75)
   (c_sort (type_farray c_int) ?t3_127_77)))))))))

;; Why axiom sub_permut_exchange_1
 :assumption
   (forall (?t_134_80 c_unique)
   (forall (?g_133_81 Int)
   (forall (?d_132_82 Int)
   (forall (?i_131_83 Int)
   (forall (?j_130_84 Int)
   (implies
   (and (<= ?g_133_81 ?i_131_83)
   (and (<= ?i_131_83 ?d_132_82)
   (and (<= ?g_133_81 ?j_130_84) (<= ?j_130_84 ?d_132_82))))
   (sub_permut ?g_133_81 ?d_132_82 (c_sort (type_farray c_int) ?t_134_80)
   (c_sort (type_farray c_int)
   (update
   (c_sort (type_farray c_int)
   (update (c_sort (type_farray c_int) ?t_134_80) ?i_131_83
   (c_sort c_int (access (c_sort (type_farray c_int) ?t_134_80) ?j_130_84))))
   ?j_130_84
   (c_sort c_int (access (c_sort (type_farray c_int) ?t_134_80) ?i_131_83)))))))))))

;; Why axiom sub_permut_exchange_2
 :assumption
   (forall (?t1_140_85 c_unique)
   (forall (?t2_139_86 c_unique)
   (forall (?g_138_87 Int)
   (forall (?d_137_88 Int)
   (forall (?i_136_89 Int)
   (forall (?j_135_90 Int)
   (implies
   (and (<= ?g_138_87 ?i_136_89)
   (and (<= ?i_136_89 ?d_137_88)
   (and (<= ?g_138_87 ?j_135_90)
   (and (<= ?j_135_90 ?d_137_88)
   (exchange (c_sort (type_farray c_int) ?t1_140_85)
   (c_sort (type_farray c_int) ?t2_139_86) ?i_136_89 ?j_135_90)))))
   (sub_permut ?g_138_87 ?d_137_88 (c_sort (type_farray c_int) ?t1_140_85)
   (c_sort (type_farray c_int) ?t2_139_86)))))))))

;; Why axiom sub_permut_permut
 :assumption
   (forall (?t1_144_91 c_unique)
   (forall (?t2_143_92 c_unique)
   (forall (?g_142_93 Int)
   (forall (?d_141_94 Int)
   (implies
   (sub_permut ?g_142_93 ?d_141_94 (c_sort (type_farray c_int) ?t1_144_91)
   (c_sort (type_farray c_int) ?t2_143_92))
   (permut (c_sort (type_farray c_int) ?t1_144_91)
   (c_sort (type_farray c_int) ?t2_143_92)))))))

;; Why axiom array_length_update
 :assumption
   (forall (?t_147_95 c_unique)
   (forall (?i_146_96 Int)
   (forall (?v_145_97 Int)
   (= (array_length
      (c_sort (type_farray c_int)
      (update (c_sort (type_farray c_int) ?t_147_95) ?i_146_96
      (c_sort c_int (int2U ?v_145_97)))))
   (array_length (c_sort (type_farray c_int) ?t_147_95))))))

;; Why axiom sub_permut_array_length
 :assumption
   (forall (?t1_151_98 c_unique)
   (forall (?t2_150_99 c_unique)
   (forall (?g_149_100 Int)
   (forall (?d_148_101 Int)
   (implies
   (sub_permut ?g_149_100 ?d_148_101 (c_sort (type_farray c_int) ?t1_151_98)
   (c_sort (type_farray c_int) ?t2_150_99))
   (= (array_length (c_sort (type_farray c_int) ?t1_151_98))
   (array_length (c_sort (type_farray c_int) ?t2_150_99))))))))

;; Why axiom permut_array_length
 :assumption
   (forall (?t1_153_102 c_unique)
   (forall (?t2_152_103 c_unique)
   (implies
   (permut (c_sort (type_farray c_int) ?t1_153_102)
   (c_sort (type_farray c_int) ?t2_152_103))
   (= (array_length (c_sort (type_farray c_int) ?t1_153_102))
   (array_length (c_sort (type_farray c_int) ?t2_152_103))))))

;;;; Why logic type_token
:extrafuns ((type_token  c_type))

;;;; Why logic r1
:extrapreds ((r1 c_ssorted))

;;;; Why logic r2
:extrapreds ((r2 c_ssorted))

;;;; Why logic r3
:extrapreds ((r3 c_ssorted))

;;;; Why logic r4
:extrapreds ((r4 c_ssorted))

;;;; Why logic w1
:extrapreds ((w1 c_ssorted))

;;;; Why logic w2
:extrapreds ((w2 c_ssorted))

;;;; Why logic w3
:extrapreds ((w3 c_ssorted))

;;;; Why logic w4
:extrapreds ((w4 c_ssorted))

;;;; Why logic rw
:extrapreds ((rw c_ssorted))

;;;; Why logic bot
:extrapreds ((bot c_ssorted))

;;;; Why logic type_lock
:extrafuns ((type_lock  c_type))

;;;; Why logic Read
:extrafuns ((Read  c_unique))

;;;; Why logic Write
:extrafuns ((Write  c_unique))

;;;; Why logic ty
:extrafuns ((ty c_ssorted c_unique))

;;;; Why logic var_y
:extrafuns ((var_y c_ssorted Int))

;;;; Why logic var_pid
:extrafuns ((var_pid c_ssorted Int))

;;;; Why logic g
:extrafuns ((g Int Int))

;;;; Why logic f
:extrafuns ((f Int Int))

;;;; Why logic is_lock
:extrapreds ((is_lock c_ssorted))

;; Why axiom def_is_lock
 :assumption
   (forall (?l_156_104 c_unique)
   (iff (is_lock (c_sort type_lock ?l_156_104))
   (or (= ?l_156_104 Read) (= ?l_156_104 Write))))


)
